#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace Xenoflight.InputServices
{
    public class KeyboardInputService : InputServiceProvider
    {
        public bool IsKeyDown(InputControls control)
        {
            KeyboardState ks = Keyboard.GetState();
            switch (control)
            {
                case InputControls.Up:
                    return ks.IsKeyDown(Keys.Up);
                case InputControls.Down:
                    return ks.IsKeyDown(Keys.Down);
                case InputControls.Left:
                    return ks.IsKeyDown(Keys.Left);
                case InputControls.Right:
                    return ks.IsKeyDown(Keys.Right);
                case InputControls.Select:
                    return ks.IsKeyDown(Keys.X) || ks.IsKeyDown(Keys.Enter);
                case InputControls.Fire1:
                    return ks.IsKeyDown(Keys.X);
                case InputControls.Fire2:
                    return ks.IsKeyDown(Keys.Z);
                case InputControls.Menu:
                    return ks.IsKeyDown(Keys.Escape);
                default:
                    throw new NotImplementedException("That control is not implemented by the current InputServiceProvider.");
            }
        }

        public bool IsKeyUp(InputControls control)
        {
            return !IsKeyDown(control);
        }
    }
}
