#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace Xenoflight.Entities.Ships
{
    class Gradius : Ship
    {
        public Gradius(GameState gs)
            : base(gs)
        {
        }

        public override MovementLimits Forwards
        {
            get { return new MovementLimits(8f, 8f); }
        }

        public override MovementLimits Backwards
        {
            get { return new MovementLimits(8f, 8f); }
        }

        public override MovementLimits Up
        {
            get { return new MovementLimits(8f, 8f); }
        }

        public override MovementLimits Down
        {
            get { return new MovementLimits(8f, 8f); }
        }

        public override Physics2DDotNet.Shape CollisionShape
        {
            get
            {
				Log.log("xeno.physics.ship", "Collision rectangle is " + (_texture.Width / _gameState._tileWidth) + "x" + (_texture.Height / _gameState._tileHeight));
                //return new Physics2DDotNet.Polygon(Physics2DDotNet.Polygon.CreateRectangle(_texture.Height/_gameState._tileHeight, _texture.Width/_gameState._tileWidth), Constants.physicsGridSize);
				return new Physics2DDotNet.Polygon(Physics2DDotNet.Polygon.CreateRectangle(1 , 2), Constants.physicsGridSize);
            }
        }

        public override float Mass
        {
            get
            {
                return 105000;
            }
        }

		public override void Collided(SpaceObject so)
		{
			Die();
		}

		public override void Die()
		{
			// I die! Oh my!
			_gameState._spriteManager.Remove(this);
		}
	}
}
