#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace Xenoflight
{
    class FPSCounter : Microsoft.Xna.Framework.DrawableGameComponent
    {
        int frames = 0;
        double fps = 0;

        SpriteFont _spriteFont;
        SpriteBatch _spriteBatch;
        Vector2 _position;
        double elapsedSeconds = 0;

        public FPSCounter(GameState gameState)
            : base(gameState._game)
        {
            ContentManager cm = new ContentManager(gameState._game.Services);
            _spriteFont = cm.Load<SpriteFont>("FPSCounter");
            _spriteBatch = new SpriteBatch(gameState._graphics.GraphicsDevice);
            _position = new Vector2(gameState._graphics.GraphicsDevice.Viewport.Width - 80, 0);
        }

        public override void Draw(GameTime gameTime)
        {
            frames++;

            _spriteBatch.Begin();
            _spriteBatch.DrawString(_spriteFont, "FPS: " + fps, _position, Color.White);
            _spriteBatch.End();

            base.Draw(gameTime);
        }

        public override void Update(GameTime gameTime)
        {
            elapsedSeconds += gameTime.ElapsedRealTime.TotalSeconds;
            if (elapsedSeconds > 1)
            {
                fps = Math.Round(frames / elapsedSeconds, 2);
                frames = 0;
                elapsedSeconds = 0;
            }

            base.Update(gameTime);
        }
    }
}


