#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace Xenoflight
{
    class MapTextLoader : MapLoader
    {
        const byte MAP_TILE_NORMAL = 0;
        const byte MAP_TILE_SOLID = 1;

        public Map Load(GameState gameState, string filename)
        {
            Map ret;

            System.IO.StreamReader sr = new System.IO.StreamReader(filename);

            string[] map = sr.ReadLine().Split(' ');
            
            if (map[0]!="xeno")
                return null;

            ret = new Map(gameState, int.Parse(map[1]), int.Parse(map[2]), map[3]);

            for (int y = 0; y < ret.Height; y++)
            {
                string[] line = sr.ReadLine().Split(' ');
                for (int x = 0; x < ret.Width; x++)
                {
                    byte type = byte.Parse(line[x * 2]);
                    switch (type)
                    {
                        case MAP_TILE_NORMAL:
                            // Regular tile
                            ret[x, y] = new Tile(x, y, int.Parse(line[x * 2 + 1]), false);
                            break;
                        case MAP_TILE_SOLID:
                            // Solid tile
                            ret[x, y] = new Tile(x, y, int.Parse(line[x * 2 + 1]), true);
                            break;
                    }
                }
            }
            return ret;
        }
    }
}
