#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion


namespace Xenoflight
{
	class PhysicsDebugger : GameComponent
	{
		GameState _gameState;
		string _facility;
		Physics2DDotNet.PhysicsEngine _engine;

		public PhysicsDebugger(GameState gameState, Physics2DDotNet.PhysicsEngine engine, string facility)
			: base(gameState._game)
		{
			_gameState = gameState;
			_engine = engine;
			_facility = facility;
			engine.BodiesAdded += new EventHandler<Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.Body>>(_physicsEngine_BodiesAdded);
			engine.BodiesRemoved += new EventHandler<Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.Body>>(_physicsEngine_BodiesRemoved);
			engine.JointsAdded += new EventHandler<Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.Joint>>(_physicsEngine_JointsAdded);
			engine.JointsRemoved += new EventHandler<Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.Joint>>(_physicsEngine_JointsRemoved);
			engine.LogicsAdded += new EventHandler<Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.PhysicsLogic>>(_physicsEngine_LogicsAdded);
			engine.LogicsRemoved += new EventHandler<Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.PhysicsLogic>>(_physicsEngine_LogicsRemoved);
		}

		void _physicsEngine_LogicsRemoved(object sender, Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.PhysicsLogic> e)
		{
			Log.log(_facility, "LogicsRemoved: " + e.Collection.Count);
		}

		void _physicsEngine_LogicsAdded(object sender, Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.PhysicsLogic> e)
		{
			Log.log(_facility, "LogicsAdded: " + e.Collection.Count);
		}

		void _physicsEngine_JointsRemoved(object sender, Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.Joint> e)
		{
			Log.log(_facility, "JointsRemoved: " + e.Collection.Count);
		}

		void _physicsEngine_JointsAdded(object sender, Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.Joint> e)
		{
			Log.log(_facility, "JointsAdded: " + e.Collection.Count);
		}

		void _physicsEngine_BodiesRemoved(object sender, Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.Body> e)
		{
			Log.log(_facility, "BodiesRemoved: " + e.Collection.Count);
		}

		void _physicsEngine_BodiesAdded(object sender, Physics2DDotNet.CollectionEventArgs<Physics2DDotNet.Body> e)
		{
			Log.log(_facility, "BodiesAdded: " + e.Collection.Count);
		}
	}
}
